



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>jQuery核心之jQuery Object及其相关的常用方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">jQuery核心之jQuery Object及其相关的常用方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 10:57:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1、jQuery Object 和 原生的DOM对象之间有许多方法是不一样的，用jQuery的方法大部分情况下返回的是jQuery Object，但是jQuery也提供了一些方法可以很轻松的获取原生的DOM对象。
<div><br>
<div>先来看：获取jQuery Object之一，</div>
</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting only the first &lt;h1&gt; element on the page (in a jQuery object)</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var headings = $( "h1" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var firstHeading = headings.eq( 0 );</code></div>
</div>
</pre>
</div>
<div>这里主要是因为headings里面包含有多个jQuery Object，所以用这个方法来获取特定的jQuery Object。</div>
<div><br></div>
<div>获取DOM 对象：</div>
<div>法1、</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting only the first &lt;h1&gt; element on the page.</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var firstHeadingElem = $( "h1" ).get( 0 );</code></div>
</div>
</pre>
</div>
<div><br></div>
<div>法2、</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting only the first &lt;h1&gt; element on the page (alternate approach).</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var firstHeadingElem = $( "h1" )[ 0 ];</code></div>
</div>
</pre>
</div>
<div>通过这两种方法获取的对象是原生DOM 对象，所以它有innerHTML，appendChild，等原生的js方法，但是没有jQuery特有的html()，after()等方法</div>
<div><br></div>
<div>还得注意：每一个通过选择器获取的jQuery Object是独一无二的，也就是它们之间的===关系总是返回false.</div>
<div>alert( $( "#logo" ) === $( "#logo" ) ); // alerts "false"<br></div>
<div><br></div>
<div>但是：用get()方法却可以获取同一个DOM 元素 ，此时它们之间的===关系返回true.</div>
<div>alert( $( "#logo" ).get(0) === $( "#logo" ).get(0) );&nbsp;</div>
<div><br></div>
<div>为了更好的区分jQuery Object和 native DOM Object 可以把$加在jQuery Object面前来标识它，这样使得代码更加容易阅读</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Comparing DOM elements (with more readable variable names).</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var $logo1 = $( "#logo" );</code></div>
</div>
<div>
<div><code>var logo1 = $logo1.get( 0 );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var $logo2 = $( "#logo" );</code></div>
</div>
<div>
<div><code>var logo2 = $logo2.get( 0 );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>alert( logo1 === logo2 ); // alerts "true"</code>&nbsp;</div>
</div>
</pre>
</div>
<div><br></div>
<div>2、遍历</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>&lt;div class="grandparent"&gt;</code></div>
</div>
<div>
<div><code>    &lt;div class="parent"&gt;</code></div>
</div>
<div>
<div><code>        &lt;div class="child"&gt;</code></div>
</div>
<div>
<div><code>            &lt;span class="subchild"&gt;&lt;/span&gt;</code></div>
</div>
<div>
<div><code>        &lt;/div&gt;</code></div>
</div>
<div>
<div><code>    &lt;/div&gt;</code></div>
</div>
<div>
<div><code>    &lt;div class="surrogateParent1"&gt;&lt;/div&gt;</code></div>
</div>
<div>
<div><code>    &lt;div class="surrogateParent2"&gt;&lt;/div&gt;</code></div>
</div>
<div>
<div><code>&lt;/div&gt;</code>&nbsp;</div>
</div>
</pre>
</div>
<div>parent方法（获取父级元素）：</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting an element's direct parent:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.child ]</code></div>
</div>
<div>
<div><code>$( "span.subchild" ).parent();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Selecting all the parents of an element that match a given selector:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.parent ]</code></div>
</div>
<div>
<div><code>$( "span.subchild" ).parents( "div.parent" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.child, div.parent, div.grandparent ]</code></div>
</div>
<div>
<div><code>$( "span.subchild" ).parents();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Selecting all the parents of an element up to, but *not including* the selector:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.child, div.parent ]</code></div>
</div>
<div>
<div><code>$( "span.subchild" ).parentsUntil( "div.grandparent" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Selecting the <b>closest</b> parent, note that only one parent will be selected</code></div>
</div>
<div>
<div><code>// and that the initial element itself is included in the search:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.child ]</code></div>
</div>
<div>
<div><code>$( "span.subchild" ).closest( "div" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.child ] as the selector is also included in the search:</code></div>
</div>
<div>
<div><code>$( "div.child" ).closest( "div" );</code>&nbsp;</div>
</div>
</pre>
</div>
<div><br></div>
<div>children方法（获取子孙元素）：</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting an element's direct children:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.parent, div.surrogateParent1, div.surrogateParent2 ]</code></div>
</div>
<div>
<div><code>$( "div.grandparent" ).children( "div" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Finding all elements within a selection that match the selector:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.child, div.parent, div.surrogateParent1, div.surrogateParent2 ]</code></div>
</div>
<div>
<div><code>$( "div.grandparent" ).find( "div" );</code>&nbsp;</div>
</div>
</pre>
</div>
<div>siblings方法（获取同级元素）：</div>
<div>注意元素里面的顺序</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting a next sibling of the selectors:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent1 ]</code></div>
</div>
<div>
<div><code>$( "div.parent" ).next();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Selecting a prev sibling of the selectors:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [] as No sibling exists before div.parent</code></div>
</div>
<div>
<div><code>$( "div.parent" ).prev();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Selecting all the next siblings of the selector:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent1, div.surrogateParent2 ]</code></div>
</div>
<div>
<div><code>$( "div.parent" ).nextAll();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent1 ]</code></div>
</div>
<div>
<div><code>$( "div.parent" ).nextAll().first();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent2 ]</code></div>
</div>
<div>
<div><code>$( "div.parent" ).nextAll().last();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Selecting all the previous siblings of the selector:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent1, div.parent ]</code></div>
</div>
<div>
<div><code>$( "div.surrogateParent2" ).prevAll();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent1 ]</code></div>
</div>
<div>
<div><code>$( "div.surrogateParent2" ).prevAll().first();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.parent ]</code></div>
</div>
<div>
<div><code>$( "div.surrogateParent2" ).prevAll().last();</code>&nbsp;</div>
</div>
</pre>
</div>
<div><br></div>
<div>获取同级（除自己以外）的所有元素</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Selecting an element's siblings in both directions that matches the given selector:</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.surrogateParent1, div.surrogateParent2 ]</code></div>
</div>
<div>
<div><code>$( "div.parent" ).siblings();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// returns [ div.parent, div.surrogateParent2 ]</code></div>
</div>
<div>
<div><code>$( "div.surrogateParent1" ).siblings();</code>&nbsp;</div>
</div>
</pre>
</div>
<div><br></div>
<div>3、CSS样式及其尺寸：</div>
<div>还有设置css的方法：</div>
<div>$("h1").css("color":"ffffff");</div>
<div>$("h1").css(</div>
<div>&nbsp; &nbsp; {</div>
<div>&nbsp; &nbsp;&nbsp;&nbsp; &nbsp; "background-color":"#6699cc";<br></div>
<div>&nbsp; &nbsp;&nbsp;}<br></div>
<div>)</div>
<div>等。</div>
<div>增加删除CSS样式类：</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Working with classes.</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>var h1 = $( "h1" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>h1.addClass( "big" );</code></div>
</div>
<div>
<div><code>h1.removeClass( "big" );</code></div>
</div>
<div>
<div><code>h1.toggleClass( "big" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>if ( h1.hasClass( "big" ) ) {</code></div>
</div>
<div>
<div><code>    ...</code></div>
</div>
<div>
<div><code>}</code></div>
</div>
</pre>
</div>
<div>addClass() 增加样式类</div>
<div>removeClass() 删除样式类</div>
<div>toggleClass("a") 如果样式类a存在，那么就删除样式类a，如果它不存在，那么就增加样式类a（起到一个样式切换的效果）</div>
<div><br></div>
<div>尺寸：</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Basic dimensions methods.</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Sets the width of all &lt;h1&gt; elements.</code></div>
</div>
<div>
<div><code>$( "h1" ).width( "50px" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Gets the width of the first &lt;h1&gt; element.</code></div>
</div>
<div>
<div><code>$( "h1" ).width();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Sets the height of all &lt;h1&gt; elements.</code></div>
</div>
<div>
<div><code>$( "h1" ).height( "50px" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Gets the height of the first &lt;h1&gt; element.</code></div>
</div>
<div>
<div><code>$( "h1" ).height();</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Returns an object containing position information for</code></div>
</div>
<div>
<div><code>// the first &lt;h1&gt; relative to its "offset (positioned) parent".</code></div>
</div>
<div>
<div><code>$( "h1" ).position();</code>&nbsp;</div>
</div>
</pre>
</div>
<div><br></div>
<div>4、数据方法（Data methods）</div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Storing and retrieving data related to an element.</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>$( "#myDiv" ).data( "keyName", { foo: "bar" } );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>$( "#myDiv" ).data( "keyName" ); // Returns { foo: "bar" }</code></div>
</div>
</pre>
</div>
<div><br></div>
<div><br></div>
<div>
<pre class="prettyprint linenums">
<div>
<div><code>// Storing a relationship between elements using .data()</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>$( "#myList li" ).each(function() {</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>    var li = $( this );</code></div>
</div>
<div>
<div><code>    var div = li.find( "div.content" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>    li.data( "contentDiv", div );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>});</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>// Later, we don't have to find the div again;</code></div>
</div>
<div>
<div><code>// we can just read it from the list item's data</code></div>
</div>
<div>
<div><code>var firstLi = $( "#myList li:first" );</code></div>
</div>
<div>
<div><code> </code></div>
</div>
<div>
<div><code>firstLi.data( "contentDiv" ).html( "new content" );</code>
<div><br></div>
</div>
</div>
</pre>
</div>
<div><br></div>
<div><br></div>
<div><br></div>
<div><br></div>
<div><br></div>
<div><a href="http://www.wiz.cn/i/5ac334c4" rel="external nofollow noreferrer">来自为知笔记(Wiz)</a></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mwej2q.html">学习SVG系列（3）：SVG Stroke属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvn45y9.html">Runner站立会议01</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydr5ddq.html">uva 10474 Where is the Marble&quest; 计数排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vvjj9.html">&lbrack;spring&rsqb;启动时报错：NoSuchMethodError&colon; javax&period;servlet&period;http&period;HttpServletResponse&period;getStatus&lpar;&rpar;I</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj42xk9.html">JavaScript typeof obj &equals;&equals;&equals; &OpenCurlyQuote;object&rsquo; 这样写有什么问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj0nod9.html">UIScrollView的基本使用和一些常用代理方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vzj5n8.html">关于link&comma; visited&comma; hover&comma; active</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k5n0z9.html">asm&colon; Writing Inline Assembly</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n46jq.html">Effective Java 第三版&mdash;&mdash;31&period;使用限定通配符来增加API的灵活性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1p6ldq.html">web服务器的原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eypn3z9.html">Elastic-Job  配置介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2epnrq.html">mysql设置远程访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/9605znj9.html">Java基础之多线程框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5pxg4q.html">Features Download Pricing Mind Maps Blog XMind的快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll30n1q.html">MySQL更改relay-bin名称导致同步停止的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv4y0xq.html">win10环境下MySql（5&period;7&period;21版本）安装过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmnxzg9.html">移动页面click延迟引发的touch问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4v6zpq.html">Springboot  如何加密，以及利用Swagger2构建Restful API</a>
		</li>
						<li><a href="https://www.batexi.com/a/9632k3n9.html">怎么让Word编辑公式又快又好</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4r0mxq.html">AngularJS Toaster</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8z7jmx9.html">setInterval对某个数值加加渐减</a>
			</li>
						<li><a href="https://www.batexi.com/a/3905p73q.html">String与StringBuilder之间区别（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m4w228.html">kb</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq41kpnq.html">20145221高其&amp;amp&semi;20145326蔡馨熠《信息安全系统设计基础》实验二 固件设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy35xd8.html">javaWeb中servlet开发&lpar;5&rpar;&mdash;&mdash;WEB开发模式：Mode I与Mode II</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kzk3j8.html">Docker 安装部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/4951n36q.html">Python基础一&period; 简介、变量、对象及引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvwn2z9.html">字节流和字符流（BufferedReader类和BufferedWriter类）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oroe58.html">远程无法连接Mysql 的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kz6m58.html">C&plus;&plus;之路进阶&mdash;&mdash;codevs2933（诗人小G）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
